/*
    Title: 	reals.h

	Copyright (c) 2000
		Cambridge University Technical Services Limited

	Copying and use of this software is subject to the terms of the
	Poly/ML licence.
*/

#ifndef _REALS_H

#define _REALS_H
#include "globals.h"

/* Real numbers are represented by the address of the value. */
#define DBLE (sizeof(double)/sizeof(word))
union db { double dble; word wrd[DBLE]; };


extern double real_arg(Handle x);
extern word *real_result(double x);

extern word *Real_addc (Handle, Handle);
extern word *Real_subc (Handle, Handle);
extern word *Real_mulc (Handle, Handle);
extern word *Real_divc (Handle, Handle);
extern word *Real_negc (Handle);
extern int Real_compc (Handle, Handle);
extern word *Real_convc (Handle);
extern word Real_intc (Handle);
extern word *Real_floatc (Handle);
extern word *Real_sqrtc (Handle);
extern word *Real_sinc (Handle);
extern word *Real_cosc (Handle);
extern word *Real_arctanc (Handle);
extern word *Real_expc (Handle);
extern word *Real_lnc (Handle);
extern pstring Real_reprc (Handle);
extern word *Real_strc(Handle hDigits, Handle hMode, Handle arg);
extern int Real_geqc(Handle y, Handle x);
extern int Real_leqc(Handle y, Handle x);
extern int Real_gtrc(Handle y, Handle x);
extern int Real_lssc(Handle y, Handle x);
extern int Real_eqc(Handle y, Handle x);
extern int Real_neqc(Handle y, Handle x);

extern word *Real_dispatchc(Handle args, Handle code);

extern void uninit_reals(void);
extern void init_reals(void);
extern void re_init_reals(void);


#endif
